;*** 4-Bit LCD_Demo Ansteuerung (c) Gonzo

;*** Pinbelegung
;*** RB4	-	D4
;*** RB5	-	D5
;*** RB6	-	D6
;*** RB7	-	D7
;*** RA0	-	E
;*** RA1	-	RS
;*** RA2	-	RW

	list	p=16f84

	#include	<p16f84.inc>

;*** Configurationsbyte
	__CONFIG  _CP_OFF & _XT_OSC & _WDT_OFF & _PWRTE_ON

;*** Definitionen
LCD_E	equ	0
LCD_RS	equ	1
LCD_RW	equ	2

;*** Variablen
TEMP	equ	0C	; Temporaere Daten
TIME	equ	0D	; Speicher fuer Wartezeit
DAT	equ	0E	; Zwischenspeicher fr Daten
CONTROL	equ	0F	; Zwischenspeicher fr Steuerbits
TEMP2	equ	10	; zweite temporaere Variable
	
;*** Programmbeginn

	org	0

	goto	main

;*** Warteschleife TIME*1ms
wait1	movlw	.125
	movwf	TEMP
	nop
	nop
	nop
	nop
	nop
	decfsz	TEMP,F
	goto	$-6
	decfsz	TIME,F
	goto	wait1
	return

;*** PIC Initialisierung
init	clrf	INTCON		; Interrupt disable
	bsf	STATUS,RP0
	movlw	b'11000'
	movwf	TRISA
	movlw	b'00001111'
	movwf	TRISB
	bcf	STATUS,RP0
	clrf	PORTA
	clrf	PORTB
	return

;*** LCD Initialisierung
lcdini	movlw	b'00110000'
	movwf	PORTB
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	movlw	.10		; 10ms Pause
	movwf	TIME
	call	wait1
	movlw	b'00110000'
	movwf	PORTB
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	movlw	.5		; 5ms Pause
	movwf	TIME
	call	wait1
	movlw	b'00110000'
	movwf	PORTB
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	movlw	.5		; 5ms Pause
	movwf	TIME
	call	wait1
	movlw	b'00100000'
	movwf	PORTB
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	movlw	.1		; 1ms Pause
	movwf	TIME
	call	wait1
	movlw	b'00101000'
	movwf	CONTROL
	call	lcd_control
	movlw	b'00001100'
	movwf	CONTROL
	call	lcd_control
	movlw	b'00000001'
	movwf	CONTROL
	call	lcd_control
	movlw	b'00000110'
	movwf	CONTROL
	call	lcd_control
	return

;*** Ausgabe eines Control-Bytes
lcd_control	movf	CONTROL,W
	andlw	b'11110000'
	movwf	PORTB
	movlw	b'11000'
	andwf	PORTA,F
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	swapf	CONTROL,W
	andlw	b'11110000'
	movwf	PORTB
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	movlw	.1
	movwf	TIME
	call	wait1
	return

;*** Setzen der Adresse im DD_RAM Adresse in CONTROL
set_adr	bsf	CONTROL,7
	call	lcd_control
	return

;*** Ausgabe eines Daten-Bytes 
lcd_data	movf	DAT,W
	andlw	b'11110000'
	movwf	PORTB
	movlw	b'11000'
	andwf	PORTA,F
	bsf	PORTA,LCD_RS
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	swapf	DAT,W
	andlw	b'11110000'
	movwf	PORTB
	bsf	PORTA,LCD_E
	nop
	bcf	PORTA,LCD_E
	bcf	PORTA,LCD_RS
	movlw	.1
	movwf	TIME
	call	wait1
	return

;*** Display shift left
shift_l	movlw	b'00011000'
	movwf	CONTROL
	call	lcd_control
	return

;*** Display shift right
shift_r	movlw	b'00011100'
	movwf	CONTROL
	call	lcd_control
	return

;*** Clear Display
clr_disp	movlw	b'00000001'
	movwf	CONTROL
	call	lcd_control
	movlw	.1
	movwf	TIME
	call	wait1
	return

;*** Return Home
ret_home	movlw	b'00000010'
	movwf	CONTROL
	call	lcd_control
	return

;*** Textausgabe
ausgabe	call	clr_disp
	call	ret_home
	movlw	010h
	movwf	CONTROL
	call	set_adr
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'M'
	movwf	DAT
	call	lcd_data
	movlw	'e'
	movwf	DAT
	call	lcd_data
	movlw	's'
	movwf	DAT
	call	lcd_data
	movlw	's'
	movwf	DAT
	call	lcd_data
	movlw	'w'
	movwf	DAT
	call	lcd_data
	movlw	'e'
	movwf	DAT
	call	lcd_data
	movlw	'r'
	movwf	DAT
	call	lcd_data
	movlw	't'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	.16
	movwf	TEMP2
	call	shift_l
	movlw	0FFh
	movwf	TIME
	call	wait1
	decfsz	TEMP2,F
	goto	$-5
	movlw	.4
	movwf	TEMP2	
loop	call	clr_disp
	call	ret_home
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'M'
	movwf	DAT
	call	lcd_data
	movlw	'e'
	movwf	DAT
	call	lcd_data
	movlw	's'
	movwf	DAT
	call	lcd_data
	movlw	's'
	movwf	DAT
	call	lcd_data
	movlw	'w'
	movwf	DAT
	call	lcd_data
	movlw	'e'
	movwf	DAT
	call	lcd_data
	movlw	'r'
	movwf	DAT
	call	lcd_data
	movlw	't'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	'*'
	movwf	DAT
	call	lcd_data
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	0FFh
	movwf	TIME
	call	wait1
	decfsz	TEMP2,F
	goto	loop
	call	clr_disp
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	0FFh
	movwf	TIME
	call	wait1
	movlw	0FFh
	movwf	TIME
	call	wait1
	return

;*** Hauptprogramm
main	call	init
	movlw	.100		; 100ms Pause
	movwf	TIME
	call	wait1
	call	lcdini
	call	ausgabe
	goto	$-1
	
	end

